#include "mbed.h"
#include "USBMouse.h"

USBMouse mouse;

int main() {
    DigitalIn psr(P1_16), psl(P1_28);
    psr.mode(PullUp); psl.mode(PullUp);
    DigitalIn swu(P1_19), swl(P1_27), swr(P0_2), swd(P1_24);
    swu.mode(PullUp); swl.mode(PullUp); swr.mode(PullUp); swd.mode(PullUp);

    int16_t x = 0;
    int16_t y = 0;
    bool swuf=false,swlf=false,swrf=false,swdf=false;
//auto repeat stating time = 1.0sec
#define REPEATTIME 100
    uint8_t repeat_timer=REPEATTIME;

    while (1) {
        if(swu==0){
            if(swuf==false){
                y--;
                swuf=true;
            } else {
                if(repeat_timer==0){
                    swuf=false;
                    repeat_timer=2;
                }
            }
        } else swuf = false;
        if(swl==0){
            if(swlf==false){
                x--;
                swlf=true;
            } else {
                if(repeat_timer==0){
                    x--;
                    repeat_timer=2;
                }
            }
        } else swlf = false;
        if(swr==0){
            if(swrf==false){
                x++;
                swrf=true;
            } else {
                if(repeat_timer==0){
                    x++;
                    repeat_timer=2;
                }
            }
        } else swrf = false;
        if(swd==0){
            if(swdf==false){
                y++;
                swdf=true;
            } else {
                if(repeat_timer==0){
                    y++;
                    repeat_timer=2;
                }
            }
        } else swdf = false;
        mouse.update(x, y,((psr==0)? 2:0)|((psl==0)? 1:0),0);
        x=0; y=0;
        if((swuf | swlf | swrf | swdf)==false)repeat_timer=REPEATTIME; else repeat_timer--;
        wait_ms(10);
    }
}